import {
  select, 
  json, 
  geoPath,
  set,
  geoCentroid,
  geoAlbersUsa,
  zoom,
  event,
  scaleSqrt,
  max
} from 'd3';

import { feature, merge } from 'topojson';
import { loadAndProcessData } from './loadAndProcessData';

const svg = select('svg');
let data;
const width = +svg.attr('width');
const height = +svg.attr('height');

//zoom!
const g = svg.append('g');
svg.call(zoom().on('zoom', ()=>{
  g.attr('transform', event.transform)
}));

let sizeScale = null;
const USmap = geoAlbersUsa();
const pathGenerator = map => geoPath().projection(map);
const radiusValue = d => d.properties['TotalVolume'];

loadAndProcessData().then(data => {  
  
  sizeScale = scaleSqrt()
    .domain([0, max(data.features, radiusValue)])
    .range([0, 3]);
  
  render(data);
});



const render = (data) => {

    g.selectAll('path')
      .data(data.features)
      .enter().append('path')
  		.attr('class', 'states')
      .attr('d', pathGenerator(USmap)) 
  	  .append('title')
  		.text(d => d);
  
    data.features.pop() //not sure why last 2 arnt working
    data.features.pop() //not sure why last 2 arnt working
  
    const num = 7
    const size = data.features[num].properties
    console.log(size)
    data.features.forEach(d => !d.properties["TotalVolume"]
                           ?    d.properties["TotalVolume"] = 0
                           : 1)
    console.log(size)
    g.append("g")
      .attr("class","circle")
      .selectAll("circle")
      .data(data.features)
      .enter().append("circle")
      .attr('cx', d => USmap(geoCentroid(d))[0])
      .attr('cy', d => USmap(geoCentroid(d))[1])
      .attr('r',d => sizeScale(radiusValue(d)))
      .attr('fill','red')

};     






